/* A simple program to show memory layout */

#include <stdio.h>
#include <stdlib.h>

int global; /* uninitialized data */
int init = 1; /* initialized data */

unsigned long get_sp(void)
{ __asm__(" movl %esp,%eax "); }

void f(int fparam)
{
    int flocal;
    printf("f sp\t%u\n", get_sp());
    printf("flocal\t%u\n", &flocal);
    printf("fparam\t%u\n", &fparam);
}

int
main(int argc, char *argv[])
{
    int local;
    extern char **environ;
    char *heap = malloc(10);

    printf("main sp\t%u\n", get_sp());
    printf("argc\t%u\n", &argc);
    printf("argv\t%u\n", argv);
    printf("argv[0]\t%u\n", argv[0]);
    printf("env\t%u\n", environ);
    printf("env[0]\t%u\n", environ[0]);
    printf("local\t%u\n", &local);
    printf("global\t%u\n", &global);
    printf("init\t%u\n", &init);
    printf("main\t%u\n", main);
    printf("f\t%u\n", f);
    printf("heap\t%u\n", heap);
    f(42);
    return 0;
}
